VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CProductFamily"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Col As Collection ' collection of Product Variants

Private m_sPFID As String
Private m_sPFName As String
Private m_sPFDescription As String
Private m_sImageFileName As String
Private m_sSizeType As String

Private m_iDeptID As Integer

Private m_lListPrice As Long
Private m_lSalePrice As Long

Private m_datDateIntro As Date
Private m_datSaleStart As Date
Private m_datSaleEnd As Date

Private Sub Class_Initialize()
    Set m_Col = New Collection
End Sub

Private Sub Class_Terminate()
    Set m_Col = Nothing
End Sub

Private Sub PrivateAddProductVariants(iSKU)

End Sub

Private Function CreateSku(ByVal iCountVariants As Integer) As String
    
    If iCountVariants < 10 Then
        CreateSku = m_sPFID & "-0" & CStr(iCountVariants)
    Else
        CreateSku = m_sPFID & "-" & CStr(iCountVariants)
    End If
    
End Function

Private Sub AddProductVariant(ByVal sColorValue As String, _
                                ByVal sPFID As String, _
                                ByVal iSizeIndex As Integer, _
                                ByVal sSizeValue As String, _
                                ByVal iCountVariants As Integer)
    
    
    Dim oProductVariant As New CProductVariant
    With oProductVariant
        .color_value = sColorValue
        .pf_id = sPFID
        .size_index = iSizeIndex
        .size_value = sSizeValue
        .sku = CreateSku(iCountVariants)
    End With
    
    m_Col.Add oProductVariant
    Set oProductVariant = Nothing
    
End Sub

Public Sub AddProductVariants(ByVal frm As Form)

    Dim iMaxSKUs As Integer
    iMaxSKUs = CInt(frm.txtSKUs)
    
    ' all the product family information has been filled in,
    ' so at this point, you have access to it.
    
    Dim iCountVariants As Integer
    iCountVariants = 0
    
    ' first determine size type
    If m_sSizeType <> sST_EMPTY Then
        ' if it's got a size type then it must have a size
        
        ' get the upper bound to know how many size types to create
        Dim iSizeTypes As Integer
        iSizeTypes = UBound(SizeTypes.Item(m_sSizeType))
        
        
        
        '   of the ones that have sizes, check and see if they have a color
        Dim bHasColor As Boolean
        bHasColor = PFHasColor()
        
        ' get the current size type for inner loops
        Dim sSizeType As String
        
        Dim iSizeTypeIndex As Integer
        
        
        If bHasColor Then
            ' max colors is 6, choose a random total colors
            ' create a record for each valid size type in each color
            
            Dim iColors As Integer
            iColors = RandomInteger(iMIN_COLORS, iMAX_COLORS)
            
            Dim iColorsIndex As Integer
            For iColorsIndex = 1 To iColors
            
                Dim sColor As String
                sColor = GetRandomColor()
                
                For iSizeTypeIndex = 0 To iSizeTypes
                
                    sSizeType = SizeTypes.Item(m_sSizeType)(iSizeTypeIndex)
                    iCountVariants = iCountVariants + 1
                               
                    AddProductVariant sColor, m_sPFID, iSizeTypeIndex, sSizeType, iCountVariants
                    
                    If MaxVariants(1, iMaxSKUs) = True Then
                        ' fall out if things are happening
                        Set frm = Nothing
                        Exit Sub
                    End If
                    
                Next iSizeTypeIndex
                
            Next iColorsIndex
            
        Else
            '   create a record for each valid size type
            For iSizeTypeIndex = 0 To iSizeTypes
            
                iCountVariants = iCountVariants + 1
                
                sSizeType = SizeTypes.Item(m_sSizeType)(iSizeTypeIndex)
                AddProductVariant "", m_sPFID, iSizeTypeIndex, sSizeType, iCountVariants
                
                If MaxVariants(1, iMaxSKUs) = True Then
                    ' fall out if things are happening
                    Set frm = Nothing
                    Exit Sub
                End If
                

            Next iSizeTypeIndex
        
        End If
       
                
    Else ' no size type
    
        iCountVariants = 1
        '   create a record
        AddProductVariant "", m_sPFID, 0, "", iCountVariants

        If MaxVariants(1, iMaxSKUs) = True Then
            ' fall out if things are happening
            
            Set frm = Nothing

            Exit Sub
        End If
        
    End If
    
   
    frm.txtProductVariant = iCountVariants
    frm.Refresh
    
End Sub

Private Function GetColor() As String

        
    Dim iUBoundColors As Integer
    iUBoundColors = UBound(SizeTypes.Item(sST_COLORS))

    Dim iColorChoice As Integer
    iColorChoice = RandomInteger(0, iUBoundColors)
   

    GetColor = SizeTypes.Item(sST_COLORS)(iColorChoice)


End Function

Private Function GetRandomColor() As String
    
    Dim sColor As String
    sColor = GetColor()
    
    Static asPFColors() As String
    
    Static bFirst
    If bFirst = False Then
    
        bFirst = True
        ReDim asPFColors(0)
        
    End If
    

    If asPFColors(0) = Empty Then
        asPFColors(0) = sColor
    Else
    
        Dim bNewColor
        Dim iUBoundPFColors As Integer
        iUBoundPFColors = UBound(asPFColors)
        
        Do
            bNewColor = True
            
            Dim i
            For i = 0 To iUBoundPFColors
                If asPFColors(i) = sColor Then
                    bNewColor = False
                End If
            Next i
            
            If bNewColor = False Then
                sColor = GetColor()
            End If
            
        Loop Until bNewColor = True
        
        ReDim Preserve asPFColors(iUBoundPFColors + 1)
        asPFColors(iUBoundPFColors + 1) = sColor
    
    End If
    
    GetRandomColor = sColor

End Function

Property Let pf_id(ByVal sPFID As String)
    m_sPFID = sPFID
End Property

Property Get pf_id() As String
    pf_id = m_sPFID
End Property

Property Let pf_name(ByVal sPFName As String)
    m_sPFName = sPFName
End Property

Property Get pf_name() As String
    pf_name = m_sPFName
End Property

Property Let pf_description(ByVal sPFDescription As String)
    m_sPFDescription = sPFDescription
End Property

Property Get pf_description() As String
    pf_description = m_sPFDescription
End Property

Property Let image_file_name(ByVal sImageFileName As String)
    m_sImageFileName = sImageFileName
End Property

Property Get image_file_name() As String
    image_file_name = m_sImageFileName
End Property

Property Let size_type(ByVal sSizeType As String)
    m_sSizeType = sSizeType
End Property

Property Get size_type() As String
    size_type = m_sSizeType
End Property

Property Let dept_id(ByVal iDeptID As Integer)
    m_iDeptID = iDeptID
End Property

Property Get dept_id() As Integer
    dept_id = m_iDeptID
End Property

Property Let list_price(ByVal lListPrice As Long)
    m_lListPrice = lListPrice
End Property

Property Get list_price() As Long
    list_price = m_lListPrice
End Property

Property Let sale_price(ByVal lSalePrice As Long)
    m_lSalePrice = lSalePrice
End Property

Property Get sale_price() As Long
    sale_price = m_lSalePrice
End Property

Property Let date_intro(ByVal datIntro As Date)
    m_datDateIntro = datIntro
End Property

Property Get date_intro() As Date
    date_intro = m_datDateIntro
End Property

Property Let sale_start(ByVal datSaleStart As Date)
    m_datSaleStart = datSaleStart
End Property

Property Get sale_start() As Date
    sale_start = m_datSaleStart
End Property

Property Let sale_end(ByVal datSaleEnd As Date)
    m_datSaleEnd = datSaleEnd
End Property

Property Get sale_end() As Date
    sale_end = m_datSaleEnd
End Property

Public Sub EnumerateVariants()
    
    Dim oProductVariant As CProductVariant
    For Each oProductVariant In m_Col
        EnumerateProductVariant oProductVariant
    Next
    Set oProductVariant = Nothing
End Sub
