Attribute VB_Name = "MConstants"
Option Explicit

Public g_iVariantCount As Integer

Public Const lSTARTING_PARENT_DEPARTMENT = 1
Public Const iMIN_SUB_DEPARTMENTS = 6
Public Const iMAX_SUB_DEPARTMENTS = 16
Public Const iMIN_PRODUCT_FAMILY = 4
Public Const iMAX_PRODUCT_FAMILY = 44
Public Const iMAX_SKU = 20000

Public Const iMIN_COLORS = 2
Public Const iMAX_COLORS = 11

Public Const iTOP_LEVEL_PARENT_ID = 0

Public Const sDEPARTMENT_PREFIX = "Department"
Public Const sPRODUCT_FAMILY_PREFIX = "AW"
Public Const sDEPARTMENT_IMAGE_FILE_NAME = ""
Public Const sPRODUCT_FAMILY_NAME = "Product Family Name"
Public Const sPRODUCT_FAMILY_DESCRIPTION = "Product Family Description"
Public Const sPRODUCT_FAMILY_IMAGE_FILE_NAME = "carabiners3.gif"

Public Const iMIN_PRICE = 5
Public Const iMAX_PRICE = 500

Public Const sST_SHIRT = "Shirt"
Public Const sST_PANT_UNI = "Pant-Uni"
Public Const sST_PANT_M = "Pant-M"
Public Const sST_PANT_W = "Pant-W"
Public Const sST_SHOE = "Shoe"
Public Const sST_EMPTY = ""
Public Const sST_COLORS = "colors"

Public Const sC_BEIGE = "beige"
Public Const sC_BLACK = "black"
Public Const sC_BLUE = "blue"
Public Const sC_BROWN = "brown"
Public Const sC_GRAY = "gray"
Public Const sC_GREEN = "green"
Public Const sC_GREEN_BROWN = "green/brown"
Public Const sC_GREEN_GRAY = "green/gray"
Public Const sC_PURPLE = "purple"
Public Const sC_RED = "red"
Public Const sC_WHITE = "white"

Public Const sDEPARTMENT_CLASS = "CDepartment"

Private m_nSizeTypes As New Collection

Public Sub CreateSizeTypes()

    Dim asSizes() As String
    ReDim asSizes(8)
    asSizes(0) = "4"
    asSizes(1) = "5"
    asSizes(2) = "6"
    asSizes(3) = "7"
    asSizes(4) = "8"
    asSizes(5) = "9"
    asSizes(6) = "10"
    asSizes(7) = "11"
    asSizes(8) = "12"
    
    m_nSizeTypes.Add asSizes(), sST_SHOE
    
    ReDim asSizes(5)
    asSizes(0) = "XS"
    asSizes(1) = "S"
    asSizes(2) = "M"
    asSizes(3) = "L"
    asSizes(4) = "XL"
    asSizes(5) = "XXL"
    
    m_nSizeTypes.Add asSizes(), sST_PANT_UNI
    m_nSizeTypes.Add asSizes(), sST_SHIRT
    
    ReDim asSizes(6)
    asSizes(0) = "4"
    asSizes(1) = "6"
    asSizes(2) = "8"
    asSizes(3) = "10"
    asSizes(4) = "12"
    asSizes(5) = "14"
    asSizes(6) = "16"
    
    m_nSizeTypes.Add asSizes(), sST_PANT_W
    
    ReDim asSizes(9)
    asSizes(0) = "28"
    asSizes(1) = "30"
    asSizes(2) = "32"
    asSizes(3) = "34"
    asSizes(4) = "36"
    asSizes(5) = "38"
    asSizes(6) = "40"
    asSizes(7) = "42"
    asSizes(8) = "44"
    asSizes(9) = "46"
    
    m_nSizeTypes.Add asSizes(), sST_PANT_M
    
    ReDim asSizes(10)
    asSizes(0) = sC_BEIGE
    asSizes(1) = sC_BLACK
    asSizes(2) = sC_BLUE
    asSizes(3) = sC_BROWN
    asSizes(4) = sC_GRAY
    asSizes(5) = sC_GREEN
    asSizes(6) = sC_GREEN_BROWN
    asSizes(7) = sC_GREEN_GRAY
    asSizes(8) = sC_PURPLE
    asSizes(9) = sC_RED
    asSizes(10) = sC_WHITE
        
    m_nSizeTypes.Add asSizes, sST_COLORS
End Sub

Public Function SizeTypes() As Collection
    Set SizeTypes = m_nSizeTypes
End Function

Public Sub DestroySizeTypes()
    Set m_nSizeTypes = Nothing
End Sub

Public Function RandomInteger(ByVal iMin As Integer, ByVal iMax As Integer) As Integer

    Randomize
    RandomInteger = Int((iMax - iMin + 1) * Rnd + iMin)  ' Generate random value between iMin and iMax.
    
End Function

Public Sub EnumerateProductVariant(ByVal oProductVariant As CProductVariant)
    
    With oProductVariant
    
        Write #3, .sku, .pf_id, .color_value, .size_value, .size_index

    End With


End Sub

Public Sub EnumerateProductFamily(ByVal oProductFamily As CProductFamily, ByVal bJulian As Boolean)
    
    With oProductFamily
        If bJulian Then
            Write #2, .pf_id; .pf_name; .pf_description; .dept_id; .size_type; CStr(CDbl(.date_intro)); .list_price; .sale_price; CStr(CDbl(.sale_start)); CStr(CDbl(.sale_end)); .image_file_name
        Else
            Write #2, .pf_id; .pf_name; .pf_description; .dept_id; .size_type; Format(.date_intro, "mm/dd/yy hh:mm"); .list_price; .sale_price; Format(.sale_start, "mm/dd/yy hh:mm"); Format(.sale_end, "mm/dd/yy hh:mm"); .image_file_name
        End If
    End With
    
End Sub

Public Sub EnumerateDepartment(ByVal oDepartment As CDepartment)
        
        With oDepartment
                
            Debug.Print "Department: " & .dept_id & " Parent: " & .parent_id & " Featured PFID: " & .featured_pf_id
            Write #1, .dept_id; .parent_id; .dept_name; .image_file_name; .featured_pf_id
                        
        End With

End Sub

Public Function RandomSizeType() As String
    ' Shirt , Pant - Uni, Pant - M, Pant - W, Shoe, Empty
    Dim iSizeType As Integer
    iSizeType = RandomInteger(1, 8)
    
    Dim sSizeType As String
    
    Select Case iSizeType
        Case 1
            sSizeType = sST_SHIRT
        Case 2
            sSizeType = sST_PANT_UNI
        Case 3
            sSizeType = sST_PANT_M
        Case 4
            sSizeType = sST_PANT_W
        Case 5
            sSizeType = sST_SHOE
        Case 6, 7, 8
            sSizeType = sST_EMPTY
        
    End Select
    
    RandomSizeType = sSizeType
    
End Function

Public Function RandomDateIntro() As Date

    Dim iMonth As Integer
    iMonth = RandomInteger(1, 12)
    
    Dim datIntro As Date
    
    Select Case iMonth
        Case 1
            datIntro = DateValue("1/1/96")
        Case 2
            datIntro = DateValue("2/1/96")
        Case 3
            datIntro = DateValue("3/1/96")
        Case 4
            datIntro = DateValue("4/1/96")
        Case 5
            datIntro = DateValue("5/1/96")
        Case 6
            datIntro = DateValue("6/1/96")
        Case 7
            datIntro = DateValue("7/1/96")
        Case 8
            datIntro = DateValue("8/1/96")
        Case 9
            datIntro = DateValue("9/1/96")
        Case 10
            datIntro = DateValue("10/1/96")
        Case 11
            datIntro = DateValue("11/1/96")
        Case 12
            datIntro = DateValue("12/1/96")
        
    End Select
    
    RandomDateIntro = datIntro
    
End Function

Public Function RandomSalePrice(ByVal lListPrice As Long) As Long
    ' .75, .8, .85, .9, .95
    Dim iChoice As Integer
    iChoice = RandomInteger(1, 5)
    
    Dim lSalePrice As Long
    Select Case iChoice
    
        Case 1
            lSalePrice = lListPrice * 0.75
        Case 2
            lSalePrice = lListPrice * 0.8
        Case 3
            lSalePrice = lListPrice * 0.85
        Case 4
            lSalePrice = lListPrice * 0.9
        Case 5
            lSalePrice = lListPrice * 0.95
        
    
    End Select
    
    RandomSalePrice = lSalePrice
    
End Function

Public Function PFHasColor() As Boolean
    Dim iChoice As Integer
    iChoice = RandomInteger(1, 10)
    If iChoice <= 4 Then
        PFHasColor = True
    Else
        PFHasColor = False
    End If
End Function

Public Function MaxVariants(ByVal iIncrement As Integer, iMax As Integer) As Boolean
    
    g_iVariantCount = g_iVariantCount + iIncrement
    
    If g_iVariantCount = iMax Then
        MaxVariants = True
        Debug.Print g_iVariantCount
    Else
        MaxVariants = False
        If g_iVariantCount Mod 100 = 0 Then
            Debug.Print g_iVariantCount
        End If
    End If
    
End Function
